Index: uspace/lib/c/include/vfs/vfs.h
===================================================================
--- uspace/lib/c/include/vfs/vfs.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/include/vfs/vfs.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -40,9 +40,16 @@
 #include <ipc/loc.h>
 #include <stdio.h>
-#include <async.h>
 
-enum vfs_change_state_type {
-	VFS_PASS_HANDLE
-};
+/** Libc version of the VFS triplet.
+ *
+ * Unique identification of a file system node
+ * within a file system instance.
+ *
+ */
+typedef struct {
+	fs_handle_t fs_handle;
+	service_id_t service_id;
+	fs_index_t index;
+} fdi_node_t;
 
 extern char *absolutize(const char *, size_t *);
@@ -52,10 +59,9 @@
 extern int unmount(const char *);
 
-extern int fhandle(FILE *, int *);
+extern int open_node(fdi_node_t *, int);
+extern int fd_node(int, fdi_node_t *);
 
-extern int fd_wait(void);
-
-extern async_exch_t *vfs_exchange_begin(void);
-extern void vfs_exchange_end(async_exch_t *);
+extern FILE *fopen_node(fdi_node_t *, const char *);
+extern int fnode(FILE *, fdi_node_t *);
 
 #endif
Index: uspace/lib/drv/generic/driver.c
===================================================================
--- uspace/lib/drv/generic/driver.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/drv/generic/driver.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -428,16 +428,6 @@
 static void driver_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg)
 {
-	sysarg_t conn_type;
-
-	if (iid == 0) {
-		/* Callback connection from devman */
-		/* XXX Use separate handler for this type of connection */
-		conn_type = DRIVER_DEVMAN;
-	} else {
-		conn_type = IPC_GET_ARG1(*icall);
-	}
-
 	/* Select interface */
-	switch (conn_type) {
+	switch ((sysarg_t) (IPC_GET_ARG1(*icall))) {
 	case DRIVER_DEVMAN:
 		/* Handle request from device manager */
Index: uspace/lib/usb/src/resolve.c
===================================================================
--- uspace/lib/usb/src/resolve.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/usb/src/resolve.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -152,5 +152,5 @@
 		if (str_length(func_start) > 0) {
 			char tmp_path[MAX_DEVICE_PATH ];
-			rc = devman_fun_get_path(dev_handle,
+			rc = devman_get_device_path(dev_handle,
 			    tmp_path, MAX_DEVICE_PATH);
 			if (rc != EOK) {
@@ -173,5 +173,5 @@
 
 	/* First try to get the device handle. */
-	rc = devman_fun_get_handle(path, &dev_handle, 0);
+	rc = devman_device_get_handle(path, &dev_handle, 0);
 	if (rc != EOK) {
 		free(path);
@@ -184,5 +184,5 @@
 		/* Get device handle first. */
 		devman_handle_t tmp_handle;
-		rc = devman_fun_get_handle(path, &tmp_handle, 0);
+		rc = devman_device_get_handle(path, &tmp_handle, 0);
 		if (rc != EOK) {
 			free(path);
Index: uspace/lib/usbvirt/src/device.c
===================================================================
--- uspace/lib/usbvirt/src/device.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/usbvirt/src/device.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -87,5 +87,5 @@
 	
 	devman_handle_t handle;
-	int rc = devman_fun_get_handle(vhc_path, &handle, 0);
+	int rc = devman_device_get_handle(vhc_path, &handle, 0);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/devman/devman.c
===================================================================
--- uspace/srv/devman/devman.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/srv/devman/devman.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -548,4 +548,14 @@
 
 	fibril_mutex_lock(&driver->driver_mutex);
+	
+	async_exch_t *exch = async_exchange_begin(driver->sess);
+	async_sess_t *sess = async_connect_me_to(EXCHANGE_SERIALIZE, exch,
+	    DRIVER_DEVMAN, 0, 0);
+	async_exchange_end(exch);
+
+	if (!sess) {
+		fibril_mutex_unlock(&driver->driver_mutex);
+		return;
+	}
 
 	/*
@@ -573,5 +583,5 @@
 		fibril_mutex_unlock(&driver->driver_mutex);
 
-		add_device(driver, dev, tree);
+		add_device(sess, driver, dev, tree);
 
 		/*
@@ -593,4 +603,6 @@
 		link = driver->devices.head.next;
 	}
+
+	async_hangup(sess);
 
 	/*
@@ -706,5 +718,6 @@
  * @param node		The device's node in the device tree.
  */
-void add_device(driver_t *drv, dev_node_t *dev, dev_tree_t *tree)
+void add_device(async_sess_t *sess, driver_t *drv, dev_node_t *dev,
+    dev_tree_t *tree)
 {
 	/*
@@ -723,5 +736,5 @@
 	}
 	
-	async_exch_t *exch = async_exchange_begin(drv->sess);
+	async_exch_t *exch = async_exchange_begin(sess);
 	
 	ipc_call_t answer;
@@ -793,7 +806,16 @@
 	fibril_mutex_unlock(&drv->driver_mutex);
 
-	/* Notify the driver about the new device. */
-	if (is_running)
-		add_device(drv, dev, tree);
+	if (is_running) {
+		/* Notify the driver about the new device. */
+		async_exch_t *exch = async_exchange_begin(drv->sess);
+		async_sess_t *sess = async_connect_me_to(EXCHANGE_SERIALIZE, exch,
+		    DRIVER_DEVMAN, 0, 0);
+		async_exchange_end(exch);
+		
+		if (sess) {
+			add_device(sess, drv, dev, tree);
+			async_hangup(sess);
+		}
+	}
 	
 	return true;
@@ -897,35 +919,4 @@
 	return dev;
 }
-
-/** Get list of device functions. */
-int dev_get_functions(dev_tree_t *tree, dev_node_t *dev,
-    devman_handle_t *hdl_buf, size_t buf_size, size_t *act_size)
-{
-	size_t act_cnt;
-	size_t buf_cnt;
-
-	assert(fibril_rwlock_is_locked(&tree->rwlock));
-
-	buf_cnt = buf_size / sizeof(devman_handle_t);
-
-	act_cnt = list_count(&dev->functions);
-	*act_size = act_cnt * sizeof(devman_handle_t);
-
-	if (buf_size % sizeof(devman_handle_t) != 0)
-		return EINVAL;
-
-	size_t pos = 0;
-	list_foreach(dev->functions, item) {
-		fun_node_t *fun =
-		    list_get_instance(item, fun_node_t, dev_functions);
-
-		if (pos < buf_cnt)
-			hdl_buf[pos] = fun->handle;
-		pos++;
-	}
-
-	return EOK;
-}
-
 
 /* Function nodes */
@@ -1154,5 +1145,5 @@
 	char *rel_path = path;
 	char *next_path_elem = NULL;
-	bool cont = (rel_path[1] != '\0');
+	bool cont = true;
 	
 	while (cont && fun != NULL) {
Index: uspace/srv/devman/devman.h
===================================================================
--- uspace/srv/devman/devman.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/srv/devman/devman.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -235,5 +235,5 @@
 extern void add_driver(driver_list_t *, driver_t *);
 extern void attach_driver(dev_node_t *, driver_t *);
-extern void add_device(driver_t *, dev_node_t *, dev_tree_t *);
+extern void add_device(async_sess_t *, driver_t *, dev_node_t *, dev_tree_t *);
 extern bool start_driver(driver_t *);
 
@@ -253,6 +253,4 @@
 extern dev_node_t *find_dev_node(dev_tree_t *tree, devman_handle_t handle);
 extern dev_node_t *find_dev_function(dev_node_t *, const char *);
-extern int dev_get_functions(dev_tree_t *tree, dev_node_t *, devman_handle_t *,
-    size_t, size_t *);
 
 extern fun_node_t *create_fun_node(void);
Index: uspace/srv/devman/main.c
===================================================================
--- uspace/srv/devman/main.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/srv/devman/main.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -497,6 +497,7 @@
 }
 
-/** Get device name. */
-static void devman_fun_get_name(ipc_callid_t iid, ipc_call_t *icall)
+/** Find device path by its handle. */
+static void devman_get_device_path_by_handle(ipc_callid_t iid,
+    ipc_call_t *icall)
 {
 	devman_handle_t handle = IPC_GET_ARG1(*icall);
@@ -522,41 +523,4 @@
 	}
 
-	size_t sent_length = str_size(fun->name);
-	if (sent_length > data_len) {
-		sent_length = data_len;
-	}
-
-	async_data_read_finalize(data_callid, fun->name, sent_length);
-	async_answer_0(iid, EOK);
-
-	free(buffer);
-}
-
-
-/** Get device path. */
-static void devman_fun_get_path(ipc_callid_t iid, ipc_call_t *icall)
-{
-	devman_handle_t handle = IPC_GET_ARG1(*icall);
-
-	fun_node_t *fun = find_fun_node(&device_tree, handle);
-	if (fun == NULL) {
-		async_answer_0(iid, ENOMEM);
-		return;
-	}
-
-	ipc_callid_t data_callid;
-	size_t data_len;
-	if (!async_data_read_receive(&data_callid, &data_len)) {
-		async_answer_0(iid, EINVAL);
-		return;
-	}
-
-	void *buffer = malloc(data_len);
-	if (buffer == NULL) {
-		async_answer_0(data_callid, ENOMEM);
-		async_answer_0(iid, ENOMEM);
-		return;
-	}
-
 	size_t sent_length = str_size(fun->pathname);
 	if (sent_length > data_len) {
@@ -568,78 +532,4 @@
 
 	free(buffer);
-}
-
-static void devman_dev_get_functions(ipc_callid_t iid, ipc_call_t *icall)
-{
-	ipc_callid_t callid;
-	size_t size;
-	size_t act_size;
-	int rc;
-	
-	if (!async_data_read_receive(&callid, &size)) {
-		async_answer_0(callid, EREFUSED);
-		async_answer_0(iid, EREFUSED);
-		return;
-	}
-	
-	fibril_rwlock_read_lock(&device_tree.rwlock);
-	
-	dev_node_t *dev = find_dev_node_no_lock(&device_tree,
-	    IPC_GET_ARG1(*icall));
-	if (dev == NULL) {
-		fibril_rwlock_read_unlock(&device_tree.rwlock);
-		async_answer_0(callid, ENOENT);
-		async_answer_0(iid, ENOENT);
-		return;
-	}
-	
-	devman_handle_t *hdl_buf = (devman_handle_t *) malloc(size);
-	if (hdl_buf == NULL) {
-		fibril_rwlock_read_unlock(&device_tree.rwlock);
-		async_answer_0(callid, ENOMEM);
-		async_answer_0(iid, ENOMEM);
-		return;
-	}
-	
-	rc = dev_get_functions(&device_tree, dev, hdl_buf, size, &act_size);
-	if (rc != EOK) {
-		fibril_rwlock_read_unlock(&device_tree.rwlock);
-		async_answer_0(callid, rc);
-		async_answer_0(iid, rc);
-		return;
-	}
-	
-	fibril_rwlock_read_unlock(&device_tree.rwlock);
-	
-	sysarg_t retval = async_data_read_finalize(callid, hdl_buf, size);
-	free(hdl_buf);
-	
-	async_answer_1(iid, retval, act_size);
-}
-
-
-/** Get handle for child device of a function. */
-static void devman_fun_get_child(ipc_callid_t iid, ipc_call_t *icall)
-{
-	fun_node_t *fun;
-	
-	fibril_rwlock_read_lock(&device_tree.rwlock);
-	
-	fun = find_fun_node(&device_tree, IPC_GET_ARG1(*icall));
-	if (fun == NULL) {
-		fibril_rwlock_read_unlock(&device_tree.rwlock);
-		async_answer_0(iid, ENOENT);
-		return;
-	}
-	
-	if (fun->child == NULL) {
-		fibril_rwlock_read_unlock(&device_tree.rwlock);
-		async_answer_0(iid, ENOENT);
-		return;
-	}
-	
-	async_answer_1(iid, EOK, fun->child->handle);
-	
-	fibril_rwlock_read_unlock(&device_tree.rwlock);
 }
 
@@ -676,15 +566,6 @@
 			devman_function_get_handle(callid, &call);
 			break;
-		case DEVMAN_DEV_GET_FUNCTIONS:
-			devman_dev_get_functions(callid, &call);
-			break;
-		case DEVMAN_FUN_GET_CHILD:
-			devman_fun_get_child(callid, &call);
-			break;
-		case DEVMAN_FUN_GET_NAME:
-			devman_fun_get_name(callid, &call);
-			break;
-		case DEVMAN_FUN_GET_PATH:
-			devman_fun_get_path(callid, &call);
+		case DEVMAN_DEVICE_GET_DEVICE_PATH:
+			devman_get_device_path_by_handle(callid, &call);
 			break;
 		case DEVMAN_FUN_SID_TO_HANDLE:
Index: uspace/srv/hid/input/port/adb_mouse.c
===================================================================
--- uspace/srv/hid/input/port/adb_mouse.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/srv/hid/input/port/adb_mouse.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -42,5 +42,4 @@
 #include <errno.h>
 #include <loc.h>
-#include <stdio.h>
 
 static mouse_dev_t *mouse_dev;
Index: uspace/srv/hw/irc/apic/apic.c
===================================================================
--- uspace/srv/hw/irc/apic/apic.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/srv/hw/irc/apic/apic.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -45,5 +45,4 @@
 #include <errno.h>
 #include <async.h>
-#include <stdio.h>
 
 #define NAME  "apic"
Index: uspace/srv/loader/main.c
===================================================================
--- uspace/srv/loader/main.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/srv/loader/main.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -61,5 +61,4 @@
 #include <elf/elf.h>
 #include <elf/elf_load.h>
-#include <vfs/vfs.h>
 
 #ifdef CONFIG_RTLD
@@ -90,5 +89,9 @@
 
 /** Number of preset files */
-static unsigned int filc = 0;
+static int filc = 0;
+/** Preset files vector */
+static fdi_node_t **filv = NULL;
+/** Buffer holding all preset files */
+static fdi_node_t *fil_buf = NULL;
 
 static elf_info_t prog_info;
@@ -236,23 +239,45 @@
 static void ldr_set_files(ipc_callid_t rid, ipc_call_t *request)
 {
-	size_t count = IPC_GET_ARG1(*request);
-
-	async_exch_t *vfs_exch = vfs_exchange_begin();
-
-	for (filc = 0; filc < count; filc++) {
-		ipc_callid_t callid;
-		int fd;
-
-		if (!async_state_change_receive(&callid, NULL, NULL, NULL)) {
-			async_answer_0(callid, EINVAL);
-			break;
+	fdi_node_t *buf;
+	size_t buf_size;
+	int rc = async_data_write_accept((void **) &buf, false, 0, 0,
+	    sizeof(fdi_node_t), &buf_size);
+	
+	if (rc == EOK) {
+		int count = buf_size / sizeof(fdi_node_t);
+		
+		/*
+		 * Allocate new filv
+		 */
+		fdi_node_t **_filv = (fdi_node_t **) calloc(count + 1, sizeof(fdi_node_t *));
+		if (_filv == NULL) {
+			free(buf);
+			async_answer_0(rid, ENOMEM);
+			return;
 		}
-		async_state_change_finalize(callid, vfs_exch);
-		fd = fd_wait();
-		assert(fd == (int) filc);
-	}
-
-	vfs_exchange_end(vfs_exch);
-
+		
+		/*
+		 * Fill the new filv with argument pointers
+		 */
+		int i;
+		for (i = 0; i < count; i++)
+			_filv[i] = &buf[i];
+		
+		_filv[count] = NULL;
+		
+		/*
+		 * Copy temporary data to global variables
+		 */
+		if (fil_buf != NULL)
+			free(fil_buf);
+		
+		if (filv != NULL)
+			free(filv);
+		
+		filc = count;
+		fil_buf = buf;
+		filv = _filv;
+	}
+	
 	async_answer_0(rid, EOK);
 }
@@ -283,4 +308,5 @@
 	
 	pcb.filc = filc;
+	pcb.filv = filv;
 	
 	if (prog_info.interp == NULL) {
Index: uspace/srv/loc/loc.h
===================================================================
--- uspace/srv/loc/loc.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/srv/loc/loc.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -36,5 +36,4 @@
 #define LOC_H_
 
-#include <ipc/loc.h>
 #include <async.h>
 #include <fibril_synch.h>
Index: uspace/srv/vfs/vfs.c
===================================================================
--- uspace/srv/vfs/vfs.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/srv/vfs/vfs.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -36,8 +36,5 @@
  */
 
-#include <vfs/vfs.h>
 #include <ipc/services.h>
-#include <abi/ipc/event.h>
-#include <event.h>
 #include <ns.h>
 #include <async.h>
@@ -48,12 +45,7 @@
 #include <as.h>
 #include <atomic.h>
-#include <macros.h>
 #include "vfs.h"
 
 #define NAME  "vfs"
-
-enum {
-	VFS_TASK_STATE_CHANGE
-};
 
 static void vfs_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg)
@@ -87,4 +79,7 @@
 		case VFS_IN_OPEN:
 			vfs_open(callid, &call);
+			break;
+		case VFS_IN_OPEN_NODE:
+			vfs_open_node(callid, &call);
 			break;
 		case VFS_IN_CLOSE:
@@ -123,8 +118,4 @@
 		case VFS_IN_DUP:
 			vfs_dup(callid, &call);
-			break;
-		case VFS_IN_WAIT_HANDLE:
-			vfs_wait_handle(callid, &call);
-			break;
 		default:
 			async_answer_0(callid, ENOTSUP);
@@ -137,19 +128,4 @@
 	 * connection fibril terminates.
 	 */
-}
-
-static void notification_received(ipc_callid_t callid, ipc_call_t *call)
-{
-	switch (IPC_GET_IMETHOD(*call)) {
-	case VFS_TASK_STATE_CHANGE:
-		if (IPC_GET_ARG1(*call) == VFS_PASS_HANDLE)
-			vfs_pass_handle(
-			    (task_id_t) MERGE_LOUP32(IPC_GET_ARG4(*call),
-			    IPC_GET_ARG5(*call)), call->in_task_id,
-			    (int) IPC_GET_ARG2(*call));
-		break;
-	default:
-		break;
-	}
 }
 
@@ -194,10 +170,4 @@
 
 	/*
-	 * Set notification handler and subscribe to notifications.
-	 */
-	async_set_interrupt_received(notification_received);
-	event_task_subscribe(EVENT_TASK_STATE_CHANGE, VFS_TASK_STATE_CHANGE);
-
-	/*
 	 * Register at the naming service.
 	 */
Index: uspace/srv/vfs/vfs.h
===================================================================
--- uspace/srv/vfs/vfs.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/srv/vfs/vfs.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -41,5 +41,4 @@
 #include <bool.h>
 #include <ipc/vfs.h>
-#include <task.h>
 
 #ifndef dprintf
@@ -176,4 +175,5 @@
 extern int vfs_lookup_internal(char *, int, vfs_lookup_res_t *,
     vfs_pair_t *, ...);
+extern int vfs_open_node_internal(vfs_lookup_res_t *);
 
 extern bool vfs_nodes_init(void);
@@ -189,7 +189,4 @@
 extern void vfs_client_data_destroy(void *);
 
-extern void vfs_pass_handle(task_id_t, task_id_t, int);
-extern int vfs_wait_handle_internal(void);
-
 extern vfs_file_t *vfs_file_get(int);
 extern void vfs_file_put(vfs_file_t *);
@@ -200,5 +197,4 @@
 extern void vfs_node_addref(vfs_node_t *);
 extern void vfs_node_delref(vfs_node_t *);
-extern int vfs_open_node_remote(vfs_node_t *);
 
 extern void vfs_register(ipc_callid_t, ipc_call_t *);
@@ -206,4 +202,5 @@
 extern void vfs_unmount(ipc_callid_t, ipc_call_t *);
 extern void vfs_open(ipc_callid_t, ipc_call_t *);
+extern void vfs_open_node(ipc_callid_t, ipc_call_t *);
 extern void vfs_sync(ipc_callid_t, ipc_call_t *);
 extern void vfs_dup(ipc_callid_t, ipc_call_t *);
@@ -218,5 +215,4 @@
 extern void vfs_unlink(ipc_callid_t, ipc_call_t *);
 extern void vfs_rename(ipc_callid_t, ipc_call_t *);
-extern void vfs_wait_handle(ipc_callid_t, ipc_call_t *);
 
 #endif
Index: uspace/srv/vfs/vfs_file.c
===================================================================
--- uspace/srv/vfs/vfs_file.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/srv/vfs/vfs_file.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -43,6 +43,4 @@
 #include <fibril.h>
 #include <fibril_synch.h>
-#include <adt/list.h>
-#include <task.h>
 #include "vfs.h"
 
@@ -52,57 +50,38 @@
 typedef struct {
 	fibril_mutex_t lock;
-	fibril_condvar_t cv;
-	list_t passed_handles;
 	vfs_file_t **files;
 } vfs_client_data_t;
 
-typedef struct {
-	link_t link;
-	int handle;
-} vfs_boxed_handle_t;
-
-static int _vfs_fd_free(vfs_client_data_t *, int);
-
 /** Initialize the table of open files. */
-static bool vfs_files_init(vfs_client_data_t *vfs_data)
-{
-	fibril_mutex_lock(&vfs_data->lock);
-	if (!vfs_data->files) {
-		vfs_data->files = malloc(MAX_OPEN_FILES * sizeof(vfs_file_t *));
-		if (!vfs_data->files) {
-			fibril_mutex_unlock(&vfs_data->lock);
+static bool vfs_files_init(void)
+{
+	fibril_mutex_lock(&VFS_DATA->lock);
+	if (!FILES) {
+		FILES = malloc(MAX_OPEN_FILES * sizeof(vfs_file_t *));
+		if (!FILES) {
+			fibril_mutex_unlock(&VFS_DATA->lock);
 			return false;
 		}
-		memset(vfs_data->files, 0, MAX_OPEN_FILES * sizeof(vfs_file_t *));
-	}
-	fibril_mutex_unlock(&vfs_data->lock);
+		memset(FILES, 0, MAX_OPEN_FILES * sizeof(vfs_file_t *));
+	}
+	fibril_mutex_unlock(&VFS_DATA->lock);
 	return true;
 }
 
 /** Cleanup the table of open files. */
-static void vfs_files_done(vfs_client_data_t *vfs_data)
+static void vfs_files_done(void)
 {
 	int i;
 
-	if (!vfs_data->files)
+	if (!FILES)
 		return;
 
 	for (i = 0; i < MAX_OPEN_FILES; i++) {
-		if (vfs_data->files[i])
-			(void) _vfs_fd_free(vfs_data, i);
-	}
-	
-	free(vfs_data->files);
-
-	while (!list_empty(&vfs_data->passed_handles)) {
-		link_t *lnk;
-		vfs_boxed_handle_t *bh;
-		
-		lnk = list_first(&vfs_data->passed_handles);
-		list_remove(lnk);
-
-		bh = list_get_instance(lnk, vfs_boxed_handle_t, link);
-		free(bh);
-	}
+		if (FILES[i]) {
+			(void) vfs_fd_free(i);
+		}
+	}
+	
+	free(FILES);
 }
 
@@ -114,6 +93,4 @@
 	if (vfs_data) {
 		fibril_mutex_initialize(&vfs_data->lock);
-		fibril_condvar_initialize(&vfs_data->cv);
-		list_initialize(&vfs_data->passed_handles);
 		vfs_data->files = NULL;
 	}
@@ -126,5 +103,5 @@
 	vfs_client_data_t *vfs_data = (vfs_client_data_t *) data;
 
-	vfs_files_done(vfs_data);
+	vfs_files_done();
 	free(vfs_data);
 }
@@ -154,7 +131,7 @@
  *			incremented.
  */
-static void vfs_file_addref(vfs_client_data_t *vfs_data, vfs_file_t *file)
-{
-	assert(fibril_mutex_is_locked(&vfs_data->lock));
+static void vfs_file_addref(vfs_file_t *file)
+{
+	assert(fibril_mutex_is_locked(&VFS_DATA->lock));
 
 	file->refcnt++;
@@ -166,9 +143,9 @@
  *			decremented.
  */
-static int vfs_file_delref(vfs_client_data_t *vfs_data, vfs_file_t *file)
+static int vfs_file_delref(vfs_file_t *file)
 {
 	int rc = EOK;
 
-	assert(fibril_mutex_is_locked(&vfs_data->lock));
+	assert(fibril_mutex_is_locked(&VFS_DATA->lock));
 
 	if (file->refcnt-- == 1) {
@@ -185,7 +162,16 @@
 }
 
-static int _vfs_fd_alloc(vfs_client_data_t *vfs_data, bool desc)
-{
-	if (!vfs_files_init(vfs_data))
+
+/** Allocate a file descriptor.
+ *
+ * @param desc If true, look for an available file descriptor
+ *             in a descending order.
+ *
+ * @return First available file descriptor or a negative error
+ *         code.
+ */
+int vfs_fd_alloc(bool desc)
+{
+	if (!vfs_files_init())
 		return ENOMEM;
 	
@@ -196,17 +182,17 @@
 		i = 0;
 	
-	fibril_mutex_lock(&vfs_data->lock);
+	fibril_mutex_lock(&VFS_DATA->lock);
 	while (true) {
-		if (!vfs_data->files[i]) {
-			vfs_data->files[i] = (vfs_file_t *) malloc(sizeof(vfs_file_t));
-			if (!vfs_data->files[i]) {
-				fibril_mutex_unlock(&vfs_data->lock);
+		if (!FILES[i]) {
+			FILES[i] = (vfs_file_t *) malloc(sizeof(vfs_file_t));
+			if (!FILES[i]) {
+				fibril_mutex_unlock(&VFS_DATA->lock);
 				return ENOMEM;
 			}
 			
-			memset(vfs_data->files[i], 0, sizeof(vfs_file_t));
-			fibril_mutex_initialize(&vfs_data->files[i]->lock);
-			vfs_file_addref(vfs_data, vfs_data->files[i]);
-			fibril_mutex_unlock(&vfs_data->lock);
+			memset(FILES[i], 0, sizeof(vfs_file_t));
+			fibril_mutex_initialize(&FILES[i]->lock);
+			vfs_file_addref(FILES[i]);
+			fibril_mutex_unlock(&VFS_DATA->lock);
 			return (int) i;
 		}
@@ -224,40 +210,7 @@
 		}
 	}
-	fibril_mutex_unlock(&vfs_data->lock);
+	fibril_mutex_unlock(&VFS_DATA->lock);
 	
 	return EMFILE;
-}
-
-/** Allocate a file descriptor.
- *
- * @param desc If true, look for an available file descriptor
- *             in a descending order.
- *
- * @return First available file descriptor or a negative error
- *         code.
- */
-int vfs_fd_alloc(bool desc)
-{
-	return _vfs_fd_alloc(VFS_DATA, desc);
-}
-
-static int _vfs_fd_free(vfs_client_data_t *vfs_data, int fd)
-{
-	int rc;
-
-	if (!vfs_files_init(vfs_data))
-		return ENOMEM;
-
-	fibril_mutex_lock(&vfs_data->lock);	
-	if ((fd < 0) || (fd >= MAX_OPEN_FILES) || !vfs_data->files[fd]) {
-		fibril_mutex_unlock(&vfs_data->lock);
-		return EBADF;
-	}
-	
-	rc = vfs_file_delref(vfs_data, vfs_data->files[fd]);
-	vfs_data->files[fd] = NULL;
-	fibril_mutex_unlock(&vfs_data->lock);
-	
-	return rc;
 }
 
@@ -271,5 +224,20 @@
 int vfs_fd_free(int fd)
 {
-	return _vfs_fd_free(VFS_DATA, fd);
+	int rc;
+
+	if (!vfs_files_init())
+		return ENOMEM;
+
+	fibril_mutex_lock(&VFS_DATA->lock);	
+	if ((fd < 0) || (fd >= MAX_OPEN_FILES) || (FILES[fd] == NULL)) {
+		fibril_mutex_unlock(&VFS_DATA->lock);
+		return EBADF;
+	}
+	
+	rc = vfs_file_delref(FILES[fd]);
+	FILES[fd] = NULL;
+	fibril_mutex_unlock(&VFS_DATA->lock);
+	
+	return rc;
 }
 
@@ -285,5 +253,5 @@
 int vfs_fd_assign(vfs_file_t *file, int fd)
 {
-	if (!vfs_files_init(VFS_DATA))
+	if (!vfs_files_init())
 		return ENOMEM;
 
@@ -295,5 +263,5 @@
 	
 	FILES[fd] = file;
-	vfs_file_addref(VFS_DATA, FILES[fd]);
+	vfs_file_addref(FILES[fd]);
 	fibril_mutex_unlock(&VFS_DATA->lock);
 	
@@ -301,41 +269,29 @@
 }
 
-static vfs_file_t *_vfs_file_get(vfs_client_data_t *vfs_data, int fd)
-{
-	if (!vfs_files_init(vfs_data))
+/** Find VFS file structure for a given file descriptor.
+ *
+ * @param fd		File descriptor.
+ *
+ * @return		VFS file structure corresponding to fd.
+ */
+vfs_file_t *vfs_file_get(int fd)
+{
+	if (!vfs_files_init())
 		return NULL;
 	
-	fibril_mutex_lock(&vfs_data->lock);
+	fibril_mutex_lock(&VFS_DATA->lock);
 	if ((fd >= 0) && (fd < MAX_OPEN_FILES)) {
-		vfs_file_t *file = vfs_data->files[fd];
+		vfs_file_t *file = FILES[fd];
 		if (file != NULL) {
-			vfs_file_addref(vfs_data, file);
-			fibril_mutex_unlock(&vfs_data->lock);
+			vfs_file_addref(file);
+			fibril_mutex_unlock(&VFS_DATA->lock);
 			return file;
 		}
 	}
-	fibril_mutex_unlock(&vfs_data->lock);
+	fibril_mutex_unlock(&VFS_DATA->lock);
 	
 	return NULL;
 }
 
-/** Find VFS file structure for a given file descriptor.
- *
- * @param fd		File descriptor.
- *
- * @return		VFS file structure corresponding to fd.
- */
-vfs_file_t *vfs_file_get(int fd)
-{
-	return _vfs_file_get(VFS_DATA, fd);
-}
-
-static void _vfs_file_put(vfs_client_data_t *vfs_data, vfs_file_t *file)
-{
-	fibril_mutex_lock(&vfs_data->lock);
-	vfs_file_delref(vfs_data, file);
-	fibril_mutex_unlock(&vfs_data->lock);
-}
-
 /** Stop using a file structure.
  *
@@ -344,90 +300,7 @@
 void vfs_file_put(vfs_file_t *file)
 {
-	_vfs_file_put(VFS_DATA, file);
-}
-
-void vfs_pass_handle(task_id_t donor_id, task_id_t acceptor_id, int donor_fd)
-{
-	vfs_client_data_t *donor_data = NULL;
-	vfs_client_data_t *acceptor_data = NULL;
-	vfs_file_t *donor_file = NULL;
-	vfs_file_t *acceptor_file = NULL;
-	vfs_boxed_handle_t *bh;
-	int acceptor_fd;
-
-	acceptor_data = async_get_client_data_by_id(acceptor_id);
-	if (!acceptor_data)
-		return;
-
-	bh = malloc(sizeof(vfs_boxed_handle_t));
-	assert(bh);
-
-	link_initialize(&bh->link);
-	bh->handle = -1;
-
-	donor_data = async_get_client_data_by_id(donor_id);
-	if (!donor_data)
-		goto out;
-
-	donor_file = _vfs_file_get(donor_data, donor_fd);
-	if (!donor_file)
-		goto out;
-
-	acceptor_fd = _vfs_fd_alloc(acceptor_data, false);
-	if (acceptor_fd < 0)
-		goto out;
-
-	bh->handle = acceptor_fd;
-
-	/*
-	 * Add a new reference to the underlying VFS node.
-	 */
-	vfs_node_addref(donor_file->node);
-	(void) vfs_open_node_remote(donor_file->node);
-
-	acceptor_file = _vfs_file_get(acceptor_data, acceptor_fd);
-	assert(acceptor_file);
-
-	/*
-	 * Inherit attributes from the donor.
-	 */
-	acceptor_file->node = donor_file->node;
-	acceptor_file->append = donor_file->append;
-	acceptor_file->pos = donor_file->pos;
-
-out:
-	fibril_mutex_lock(&acceptor_data->lock);
-	list_append(&bh->link, &acceptor_data->passed_handles);
-	fibril_condvar_broadcast(&acceptor_data->cv);
-	fibril_mutex_unlock(&acceptor_data->lock);
-
-	if (donor_data)
-		async_put_client_data_by_id(donor_id);
-	if (acceptor_data)
-		async_put_client_data_by_id(acceptor_id);
-	if (donor_file)
-		_vfs_file_put(donor_data, donor_file);
-	if (acceptor_file)
-		_vfs_file_put(acceptor_data, acceptor_file);
-
-}
-
-int vfs_wait_handle_internal(void)
-{
-	vfs_client_data_t *vfs_data = VFS_DATA;	
-	int fd;
-	
-	fibril_mutex_lock(&vfs_data->lock);
-	while (list_empty(&vfs_data->passed_handles))
-		fibril_condvar_wait(&vfs_data->cv, &vfs_data->lock);
-	link_t *lnk = list_first(&vfs_data->passed_handles);
-	list_remove(lnk);
-	fibril_mutex_unlock(&vfs_data->lock);
-
-	vfs_boxed_handle_t *bh = list_get_instance(lnk, vfs_boxed_handle_t, link);
-	fd = bh->handle;
-	free(bh);
-
-	return fd;
+	fibril_mutex_lock(&VFS_DATA->lock);
+	vfs_file_delref(file);
+	fibril_mutex_unlock(&VFS_DATA->lock);
 }
 
Index: uspace/srv/vfs/vfs_lookup.c
===================================================================
--- uspace/srv/vfs/vfs_lookup.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/srv/vfs/vfs_lookup.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -201,4 +201,37 @@
 }
 
+/** Perform a node open operation.
+ *
+ * @return EOK on success or an error code from errno.h.
+ *
+ */
+int vfs_open_node_internal(vfs_lookup_res_t *result)
+{
+	async_exch_t *exch = vfs_exchange_grab(result->triplet.fs_handle);
+	
+	ipc_call_t answer;
+	aid_t req = async_send_2(exch, VFS_OUT_OPEN_NODE,
+	    (sysarg_t) result->triplet.service_id,
+	    (sysarg_t) result->triplet.index, &answer);
+	
+	sysarg_t rc;
+	async_wait_for(req, &rc);
+	vfs_exchange_release(exch);
+	
+	if (rc == EOK) {
+		result->size =
+		    MERGE_LOUP32(IPC_GET_ARG1(answer), IPC_GET_ARG2(answer));
+		result->lnkcnt = (unsigned int) IPC_GET_ARG3(answer);
+		if (IPC_GET_ARG4(answer) & L_FILE)
+			result->type = VFS_NODE_FILE;
+		else if (IPC_GET_ARG4(answer) & L_DIRECTORY)
+			result->type = VFS_NODE_DIRECTORY;
+		else
+			result->type = VFS_NODE_UNKNOWN;
+	}
+	
+	return rc;
+}
+
 /**
  * @}
Index: uspace/srv/vfs/vfs_node.c
===================================================================
--- uspace/srv/vfs/vfs_node.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/srv/vfs/vfs_node.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -293,26 +293,4 @@
 }
 
-
-/** Perform a remote node open operation.
- *
- * @return EOK on success or an error code from errno.h.
- *
- */
-int vfs_open_node_remote(vfs_node_t *node)
-{
-	async_exch_t *exch = vfs_exchange_grab(node->fs_handle);
-	
-	ipc_call_t answer;
-	aid_t req = async_send_2(exch, VFS_OUT_OPEN_NODE,
-	    (sysarg_t) node->service_id, (sysarg_t) node->index, &answer);
-	
-	vfs_exchange_release(exch);
-
-	sysarg_t rc;
-	async_wait_for(req, &rc);
-	
-	return rc;
-}
-
 /**
  * @}
Index: uspace/srv/vfs/vfs_ops.c
===================================================================
--- uspace/srv/vfs/vfs_ops.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/srv/vfs/vfs_ops.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -618,4 +618,77 @@
 }
 
+void vfs_open_node(ipc_callid_t rid, ipc_call_t *request)
+{
+	// FIXME: check for sanity of the supplied fs, dev and index
+	
+	/*
+	 * The interface is open_node(fs, dev, index, oflag).
+	 */
+	vfs_lookup_res_t lr;
+	
+	lr.triplet.fs_handle = IPC_GET_ARG1(*request);
+	lr.triplet.service_id = IPC_GET_ARG2(*request);
+	lr.triplet.index = IPC_GET_ARG3(*request);
+	int oflag = IPC_GET_ARG4(*request);
+	
+	fibril_rwlock_read_lock(&namespace_rwlock);
+	
+	int rc = vfs_open_node_internal(&lr);
+	if (rc != EOK) {
+		fibril_rwlock_read_unlock(&namespace_rwlock);
+		async_answer_0(rid, rc);
+		return;
+	}
+	
+	vfs_node_t *node = vfs_node_get(&lr);
+	fibril_rwlock_read_unlock(&namespace_rwlock);
+	
+	/* Truncate the file if requested and if necessary. */
+	if (oflag & O_TRUNC) {
+		fibril_rwlock_write_lock(&node->contents_rwlock);
+		if (node->size) {
+			rc = vfs_truncate_internal(node->fs_handle,
+			    node->service_id, node->index, 0);
+			if (rc) {
+				fibril_rwlock_write_unlock(&node->contents_rwlock);
+				vfs_node_put(node);
+				async_answer_0(rid, rc);
+				return;
+			}
+			node->size = 0;
+		}
+		fibril_rwlock_write_unlock(&node->contents_rwlock);
+	}
+	
+	/*
+	 * Get ourselves a file descriptor and the corresponding vfs_file_t
+	 * structure.
+	 */
+	int fd = vfs_fd_alloc((oflag & O_DESC) != 0);
+	if (fd < 0) {
+		vfs_node_put(node);
+		async_answer_0(rid, fd);
+		return;
+	}
+	vfs_file_t *file = vfs_file_get(fd);
+	file->node = node;
+	if (oflag & O_APPEND)
+		file->append = true;
+	
+	/*
+	 * The following increase in reference count is for the fact that the
+	 * file is being opened and that a file structure is pointing to it.
+	 * It is necessary so that the file will not disappear when
+	 * vfs_node_put() is called. The reference will be dropped by the
+	 * respective VFS_IN_CLOSE.
+	 */
+	vfs_node_addref(node);
+	vfs_node_put(node);
+	vfs_file_put(file);
+	
+	/* Success! Return the new file descriptor to the client. */
+	async_answer_1(rid, EOK, fd);
+}
+
 void vfs_sync(ipc_callid_t rid, ipc_call_t *request)
 {
@@ -1276,10 +1349,4 @@
 }
 
-void vfs_wait_handle(ipc_callid_t rid, ipc_call_t *request)
-{
-	int fd = vfs_wait_handle_internal();
-	async_answer_1(rid, EOK, fd);
-}
-
 /**
  * @}
